/* ***********************************************************
 * This file was automatically generated on 2020-07-24.      *
 *                                                           *
 * Octave Bindings Version 2.0.28                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import org.octave.OctaveReference;

/**
 * Measures distance between 2cm and 400cm with ultrasound
 */
public class BrickletDistanceUS extends Device {
	public final static int DEVICE_IDENTIFIER = 229;
	public final static String DEVICE_DISPLAY_NAME = "Distance US Bricklet";

	public final static byte FUNCTION_GET_DISTANCE_VALUE = (byte)1;
	public final static byte FUNCTION_SET_DISTANCE_CALLBACK_PERIOD = (byte)2;
	public final static byte FUNCTION_GET_DISTANCE_CALLBACK_PERIOD = (byte)3;
	public final static byte FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD = (byte)4;
	public final static byte FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD = (byte)5;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)6;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)7;
	public final static byte FUNCTION_SET_MOVING_AVERAGE = (byte)10;
	public final static byte FUNCTION_GET_MOVING_AVERAGE = (byte)11;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_DISTANCE = 8;
	private final static int CALLBACK_DISTANCE_REACHED = 9;

	public final static String THRESHOLD_OPTION_OFF = new String(new char[]{'x'});
	public final static String THRESHOLD_OPTION_OUTSIDE = new String(new char[]{'o'});
	public final static String THRESHOLD_OPTION_INSIDE = new String(new char[]{'i'});
	public final static String THRESHOLD_OPTION_SMALLER = new String(new char[]{'<'});
	public final static String THRESHOLD_OPTION_GREATER = new String(new char[]{'>'});

	private List<OctaveReference> listenerDistance = new CopyOnWriteArrayList<OctaveReference>();
	private List<OctaveReference> listenerDistanceReached = new CopyOnWriteArrayList<OctaveReference>();

	public class DistanceCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;

		public int distance;

		public DistanceCallbackData(Object device, int distance) {
			super(device);

			this.distance = distance;
		}

		public String toString() {
			return "[" + "distance = " + distance + "]";
		}
	}

	public class DistanceReachedCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;

		public int distance;

		public DistanceReachedCallbackData(Object device, int distance) {
			super(device);

			this.distance = distance;
		}

		public String toString() {
			return "[" + "distance = " + distance + "]";
		}
	}

	public class DistanceCallbackThreshold {
		public String option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletDistanceUS(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 1;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DISTANCE_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_DISTANCE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DISTANCE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_MOVING_AVERAGE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_MOVING_AVERAGE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_DISTANCE] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int distance = IPConnectionBase.unsignedShort(bb.getShort());

				for (OctaveReference listener: listenerDistance) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new DistanceCallbackData(device, distance)});
				}
			}
		};

		callbacks[CALLBACK_DISTANCE_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int distance = IPConnectionBase.unsignedShort(bb.getShort());

				for (OctaveReference listener: listenerDistanceReached) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new DistanceReachedCallbackData(device, distance)});
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Returns the current distance value measured by the sensor.
	 * A small value corresponds to a small distance, a big
	 * value corresponds to a big distance. The relation between the measured distance
	 * value and the actual distance is affected by the 5V supply voltage (deviations
	 * in the supply voltage result in deviations in the distance values) and is
	 * non-linear (resolution is bigger at close range).
	 * 
	 * If you want to get the distance value periodically, it is recommended to
	 * use the {@link BrickletDistanceUS.DistanceListener} listener and set the period with
	 * {@link BrickletDistanceUS#setDistanceCallbackPeriod(long)}.
	 */
	public int getDistanceValue() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DISTANCE_VALUE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int distance = IPConnectionBase.unsignedShort(bb.getShort());

		return distance;
	}

	/**
	 * Sets the period with which the {@link BrickletDistanceUS.DistanceListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * Der {@link BrickletDistanceUS.DistanceListener} listener is only triggered if the distance value has changed
	 * since the last triggering.
	 */
	public void setDistanceCallbackPeriod(long period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DISTANCE_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the period as set by {@link BrickletDistanceUS#setDistanceCallbackPeriod(long)}.
	 */
	public long getDistanceCallbackPeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DISTANCE_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnectionBase.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the thresholds for the {@link BrickletDistanceUS.DistanceReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the distance value is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the distance value is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the distance value is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the distance value is greater than the min value (max is ignored)"
	 * \endverbatim
	 */
	public void setDistanceCallbackThreshold(String option, int min, int max) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD, this);

		bb.put((byte)option.charAt(0));
		bb.putShort((short)min);
		bb.putShort((short)max);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the threshold as set by {@link BrickletDistanceUS#setDistanceCallbackThreshold(String, int, int)}.
	 */
	public DistanceCallbackThreshold getDistanceCallbackThreshold() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array(), 13);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		DistanceCallbackThreshold obj = new DistanceCallbackThreshold();
		obj.option = new String(new char[]{(char)(bb.get())});
		obj.min = IPConnectionBase.unsignedShort(bb.getShort());
		obj.max = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Sets the period with which the threshold listeners
	 * 
	 * * {@link BrickletDistanceUS.DistanceReachedListener},
	 * 
	 * are triggered, if the thresholds
	 * 
	 * * {@link BrickletDistanceUS#setDistanceCallbackThreshold(String, int, int)},
	 * 
	 * keep being reached.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the debounce period as set by {@link BrickletDistanceUS#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnectionBase.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Sets the length of a `moving averaging &lt;https://en.wikipedia.org/wiki/Moving_average&gt;`__
	 * for the distance value.
	 * 
	 * Setting the length to 0 will turn the averaging completely off. With less
	 * averaging, there is more noise on the data.
	 */
	public void setMovingAverage(short average) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_MOVING_AVERAGE, this);

		bb.put((byte)average);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the length moving average as set by {@link BrickletDistanceUS#setMovingAverage(short)}.
	 */
	public short getMovingAverage() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_MOVING_AVERAGE, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short average = IPConnectionBase.unsignedByte(bb.get());

		return average;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = new String(new char[]{(char)(bb.get())});
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Distance listener.
	 */
	public void addDistanceCallback(OctaveReference listener) {
		listenerDistance.add(listener);
	}

	/**
	 * Removes a Distance listener.
	 */
	public void removeDistanceCallback(OctaveReference listener) {
		listenerDistance.remove(listener);
	}

	/**
	 * Adds a DistanceReached listener.
	 */
	public void addDistanceReachedCallback(OctaveReference listener) {
		listenerDistanceReached.add(listener);
	}

	/**
	 * Removes a DistanceReached listener.
	 */
	public void removeDistanceReachedCallback(OctaveReference listener) {
		listenerDistanceReached.remove(listener);
	}
}
