/* ***********************************************************
 * This file was automatically generated on 2020-07-24.      *
 *                                                           *
 * Octave Bindings Version 2.0.28                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import org.octave.OctaveReference;

/**
 * 2-axis joystick with push-button
 */
public class BrickletJoystick extends Device {
	public final static int DEVICE_IDENTIFIER = 210;
	public final static String DEVICE_DISPLAY_NAME = "Joystick Bricklet";

	public final static byte FUNCTION_GET_POSITION = (byte)1;
	public final static byte FUNCTION_IS_PRESSED = (byte)2;
	public final static byte FUNCTION_GET_ANALOG_VALUE = (byte)3;
	public final static byte FUNCTION_CALIBRATE = (byte)4;
	public final static byte FUNCTION_SET_POSITION_CALLBACK_PERIOD = (byte)5;
	public final static byte FUNCTION_GET_POSITION_CALLBACK_PERIOD = (byte)6;
	public final static byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = (byte)7;
	public final static byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = (byte)8;
	public final static byte FUNCTION_SET_POSITION_CALLBACK_THRESHOLD = (byte)9;
	public final static byte FUNCTION_GET_POSITION_CALLBACK_THRESHOLD = (byte)10;
	public final static byte FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = (byte)11;
	public final static byte FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = (byte)12;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)13;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)14;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_POSITION = 15;
	private final static int CALLBACK_ANALOG_VALUE = 16;
	private final static int CALLBACK_POSITION_REACHED = 17;
	private final static int CALLBACK_ANALOG_VALUE_REACHED = 18;
	private final static int CALLBACK_PRESSED = 19;
	private final static int CALLBACK_RELEASED = 20;

	public final static String THRESHOLD_OPTION_OFF = new String(new char[]{'x'});
	public final static String THRESHOLD_OPTION_OUTSIDE = new String(new char[]{'o'});
	public final static String THRESHOLD_OPTION_INSIDE = new String(new char[]{'i'});
	public final static String THRESHOLD_OPTION_SMALLER = new String(new char[]{'<'});
	public final static String THRESHOLD_OPTION_GREATER = new String(new char[]{'>'});

	private List<OctaveReference> listenerPosition = new CopyOnWriteArrayList<OctaveReference>();
	private List<OctaveReference> listenerAnalogValue = new CopyOnWriteArrayList<OctaveReference>();
	private List<OctaveReference> listenerPositionReached = new CopyOnWriteArrayList<OctaveReference>();
	private List<OctaveReference> listenerAnalogValueReached = new CopyOnWriteArrayList<OctaveReference>();
	private List<OctaveReference> listenerPressed = new CopyOnWriteArrayList<OctaveReference>();
	private List<OctaveReference> listenerReleased = new CopyOnWriteArrayList<OctaveReference>();

	public class PositionCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;

		public short x;
		public short y;

		public PositionCallbackData(Object device, short x, short y) {
			super(device);

			this.x = x;
			this.y = y;
		}

		public String toString() {
			return "[" + "x = " + x + ", " + "y = " + y + "]";
		}
	}

	public class AnalogValueCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;

		public int x;
		public int y;

		public AnalogValueCallbackData(Object device, int x, int y) {
			super(device);

			this.x = x;
			this.y = y;
		}

		public String toString() {
			return "[" + "x = " + x + ", " + "y = " + y + "]";
		}
	}

	public class PositionReachedCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;

		public short x;
		public short y;

		public PositionReachedCallbackData(Object device, short x, short y) {
			super(device);

			this.x = x;
			this.y = y;
		}

		public String toString() {
			return "[" + "x = " + x + ", " + "y = " + y + "]";
		}
	}

	public class AnalogValueReachedCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;

		public int x;
		public int y;

		public AnalogValueReachedCallbackData(Object device, int x, int y) {
			super(device);

			this.x = x;
			this.y = y;
		}

		public String toString() {
			return "[" + "x = " + x + ", " + "y = " + y + "]";
		}
	}

	public class PressedCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;



		public PressedCallbackData(Object device) {
			super(device);


		}

		public String toString() {
			return "[" +  "]";
		}
	}

	public class ReleasedCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;



		public ReleasedCallbackData(Object device) {
			super(device);


		}

		public String toString() {
			return "[" +  "]";
		}
	}

	public class Position {
		public short x;
		public short y;

		public String toString() {
			return "[" + "x = " + x + ", " + "y = " + y + "]";
		}
	}

	public class AnalogValue {
		public int x;
		public int y;

		public String toString() {
			return "[" + "x = " + x + ", " + "y = " + y + "]";
		}
	}

	public class PositionCallbackThreshold {
		public String option;
		public short minX;
		public short maxX;
		public short minY;
		public short maxY;

		public String toString() {
			return "[" + "option = " + option + ", " + "minX = " + minX + ", " + "maxX = " + maxX + ", " + "minY = " + minY + ", " + "maxY = " + maxY + "]";
		}
	}

	public class AnalogValueCallbackThreshold {
		public String option;
		public int minX;
		public int maxX;
		public int minY;
		public int maxY;

		public String toString() {
			return "[" + "option = " + option + ", " + "minX = " + minX + ", " + "maxX = " + maxX + ", " + "minY = " + minY + ", " + "maxY = " + maxY + "]";
		}
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletJoystick(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_POSITION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_IS_PRESSED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ANALOG_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_CALIBRATE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_POSITION_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_POSITION_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_POSITION_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_POSITION_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_POSITION] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 12) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short x = (bb.getShort());
				short y = (bb.getShort());

				for (OctaveReference listener: listenerPosition) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new PositionCallbackData(device, x, y)});
				}
			}
		};

		callbacks[CALLBACK_ANALOG_VALUE] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 12) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int x = IPConnectionBase.unsignedShort(bb.getShort());
				int y = IPConnectionBase.unsignedShort(bb.getShort());

				for (OctaveReference listener: listenerAnalogValue) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new AnalogValueCallbackData(device, x, y)});
				}
			}
		};

		callbacks[CALLBACK_POSITION_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 12) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short x = (bb.getShort());
				short y = (bb.getShort());

				for (OctaveReference listener: listenerPositionReached) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new PositionReachedCallbackData(device, x, y)});
				}
			}
		};

		callbacks[CALLBACK_ANALOG_VALUE_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 12) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int x = IPConnectionBase.unsignedShort(bb.getShort());
				int y = IPConnectionBase.unsignedShort(bb.getShort());

				for (OctaveReference listener: listenerAnalogValueReached) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new AnalogValueReachedCallbackData(device, x, y)});
				}
			}
		};

		callbacks[CALLBACK_PRESSED] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 8) {
					return; // silently ignoring callback with wrong length
				}

				for (OctaveReference listener: listenerPressed) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new PressedCallbackData(device)});
				}
			}
		};

		callbacks[CALLBACK_RELEASED] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 8) {
					return; // silently ignoring callback with wrong length
				}

				for (OctaveReference listener: listenerReleased) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new ReleasedCallbackData(device)});
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Returns the position of the joystick. The middle position of the joystick is x=0, y=0.
	 * The returned values are averaged and calibrated (see {@link BrickletJoystick#calibrate()}).
	 * 
	 * If you want to get the position periodically, it is recommended to use the
	 * {@link BrickletJoystick.PositionListener} listener and set the period with
	 * {@link BrickletJoystick#setPositionCallbackPeriod(long)}.
	 */
	public Position getPosition() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_POSITION, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Position obj = new Position();
		obj.x = (bb.getShort());
		obj.y = (bb.getShort());

		return obj;
	}

	/**
	 * Returns *true* if the button is pressed and *false* otherwise.
	 * 
	 * It is recommended to use the {@link BrickletJoystick.PressedListener} and {@link BrickletJoystick.ReleasedListener} listeners
	 * to handle the button.
	 */
	public boolean isPressed() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_PRESSED, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean pressed = (bb.get()) != 0;

		return pressed;
	}

	/**
	 * Returns the values as read by a 12-bit analog-to-digital converter.
	 * 
	 * \note
	 *  The values returned by {@link BrickletJoystick#getPosition()} are averaged over several samples
	 *  to yield less noise, while {@link BrickletJoystick#getAnalogValue()} gives back raw
	 *  unfiltered analog values. The only reason to use {@link BrickletJoystick#getAnalogValue()} is,
	 *  if you need the full resolution of the analog-to-digital converter.
	 * 
	 * If you want the analog values periodically, it is recommended to use the
	 * {@link BrickletJoystick.AnalogValueListener} listener and set the period with
	 * {@link BrickletJoystick#setAnalogValueCallbackPeriod(long)}.
	 */
	public AnalogValue getAnalogValue() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ANALOG_VALUE, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AnalogValue obj = new AnalogValue();
		obj.x = IPConnectionBase.unsignedShort(bb.getShort());
		obj.y = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Calibrates the middle position of the joystick. If your Joystick Bricklet
	 * does not return x=0 and y=0 in the middle position, call this function
	 * while the joystick is standing still in the middle position.
	 * 
	 * The resulting calibration will be saved on the EEPROM of the Joystick
	 * Bricklet, thus you only have to calibrate it once.
	 */
	public void calibrate() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_CALIBRATE, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Sets the period with which the {@link BrickletJoystick.PositionListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletJoystick.PositionListener} listener is only triggered if the position has changed since the
	 * last triggering.
	 */
	public void setPositionCallbackPeriod(long period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_POSITION_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the period as set by {@link BrickletJoystick#setPositionCallbackPeriod(long)}.
	 */
	public long getPositionCallbackPeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_POSITION_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnectionBase.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickletJoystick.AnalogValueListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletJoystick.AnalogValueListener} listener is only triggered if the analog values have
	 * changed since the last triggering.
	 */
	public void setAnalogValueCallbackPeriod(long period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the period as set by {@link BrickletJoystick#setAnalogValueCallbackPeriod(long)}.
	 */
	public long getAnalogValueCallbackPeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnectionBase.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the thresholds for the {@link BrickletJoystick.PositionReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the position is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the position is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the position is smaller than the min values (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the position is greater than the min values (max is ignored)"
	 * \endverbatim
	 */
	public void setPositionCallbackThreshold(String option, short minX, short maxX, short minY, short maxY) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)17, FUNCTION_SET_POSITION_CALLBACK_THRESHOLD, this);

		bb.put((byte)option.charAt(0));
		bb.putShort(minX);
		bb.putShort(maxX);
		bb.putShort(minY);
		bb.putShort(maxY);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the threshold as set by {@link BrickletJoystick#setPositionCallbackThreshold(String, short, short, short, short)}.
	 */
	public PositionCallbackThreshold getPositionCallbackThreshold() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_POSITION_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array(), 17);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		PositionCallbackThreshold obj = new PositionCallbackThreshold();
		obj.option = new String(new char[]{(char)(bb.get())});
		obj.minX = (bb.getShort());
		obj.maxX = (bb.getShort());
		obj.minY = (bb.getShort());
		obj.maxY = (bb.getShort());

		return obj;
	}

	/**
	 * Sets the thresholds for the {@link BrickletJoystick.AnalogValueReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the analog values are *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the analog values are *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the analog values are smaller than the min values (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the analog values are greater than the min values (max is ignored)"
	 * \endverbatim
	 */
	public void setAnalogValueCallbackThreshold(String option, int minX, int maxX, int minY, int maxY) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)17, FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, this);

		bb.put((byte)option.charAt(0));
		bb.putShort((short)minX);
		bb.putShort((short)maxX);
		bb.putShort((short)minY);
		bb.putShort((short)maxY);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the threshold as set by {@link BrickletJoystick#setAnalogValueCallbackThreshold(String, int, int, int, int)}.
	 */
	public AnalogValueCallbackThreshold getAnalogValueCallbackThreshold() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array(), 17);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AnalogValueCallbackThreshold obj = new AnalogValueCallbackThreshold();
		obj.option = new String(new char[]{(char)(bb.get())});
		obj.minX = IPConnectionBase.unsignedShort(bb.getShort());
		obj.maxX = IPConnectionBase.unsignedShort(bb.getShort());
		obj.minY = IPConnectionBase.unsignedShort(bb.getShort());
		obj.maxY = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Sets the period with which the threshold listeners
	 * 
	 * * {@link BrickletJoystick.PositionReachedListener},
	 * * {@link BrickletJoystick.AnalogValueReachedListener}
	 * 
	 * are triggered, if the thresholds
	 * 
	 * * {@link BrickletJoystick#setPositionCallbackThreshold(String, short, short, short, short)},
	 * * {@link BrickletJoystick#setAnalogValueCallbackThreshold(String, int, int, int, int)}
	 * 
	 * keep being reached.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the debounce period as set by {@link BrickletJoystick#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnectionBase.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = new String(new char[]{(char)(bb.get())});
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Position listener.
	 */
	public void addPositionCallback(OctaveReference listener) {
		listenerPosition.add(listener);
	}

	/**
	 * Removes a Position listener.
	 */
	public void removePositionCallback(OctaveReference listener) {
		listenerPosition.remove(listener);
	}

	/**
	 * Adds a AnalogValue listener.
	 */
	public void addAnalogValueCallback(OctaveReference listener) {
		listenerAnalogValue.add(listener);
	}

	/**
	 * Removes a AnalogValue listener.
	 */
	public void removeAnalogValueCallback(OctaveReference listener) {
		listenerAnalogValue.remove(listener);
	}

	/**
	 * Adds a PositionReached listener.
	 */
	public void addPositionReachedCallback(OctaveReference listener) {
		listenerPositionReached.add(listener);
	}

	/**
	 * Removes a PositionReached listener.
	 */
	public void removePositionReachedCallback(OctaveReference listener) {
		listenerPositionReached.remove(listener);
	}

	/**
	 * Adds a AnalogValueReached listener.
	 */
	public void addAnalogValueReachedCallback(OctaveReference listener) {
		listenerAnalogValueReached.add(listener);
	}

	/**
	 * Removes a AnalogValueReached listener.
	 */
	public void removeAnalogValueReachedCallback(OctaveReference listener) {
		listenerAnalogValueReached.remove(listener);
	}

	/**
	 * Adds a Pressed listener.
	 */
	public void addPressedCallback(OctaveReference listener) {
		listenerPressed.add(listener);
	}

	/**
	 * Removes a Pressed listener.
	 */
	public void removePressedCallback(OctaveReference listener) {
		listenerPressed.remove(listener);
	}

	/**
	 * Adds a Released listener.
	 */
	public void addReleasedCallback(OctaveReference listener) {
		listenerReleased.add(listener);
	}

	/**
	 * Removes a Released listener.
	 */
	public void removeReleasedCallback(OctaveReference listener) {
		listenerReleased.remove(listener);
	}
}
