/* ***********************************************************
 * This file was automatically generated on 2020-07-24.      *
 *                                                           *
 * Octave Bindings Version 2.0.28                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import org.octave.OctaveReference;

/**
 * Communicates with RS232 devices
 */
public class BrickletRS232 extends Device {
	public final static int DEVICE_IDENTIFIER = 254;
	public final static String DEVICE_DISPLAY_NAME = "RS232 Bricklet";

	public final static byte FUNCTION_WRITE = (byte)1;
	public final static byte FUNCTION_READ = (byte)2;
	public final static byte FUNCTION_ENABLE_READ_CALLBACK = (byte)3;
	public final static byte FUNCTION_DISABLE_READ_CALLBACK = (byte)4;
	public final static byte FUNCTION_IS_READ_CALLBACK_ENABLED = (byte)5;
	public final static byte FUNCTION_SET_CONFIGURATION = (byte)6;
	public final static byte FUNCTION_GET_CONFIGURATION = (byte)7;
	public final static byte FUNCTION_SET_BREAK_CONDITION = (byte)10;
	public final static byte FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION = (byte)11;
	public final static byte FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION = (byte)12;
	public final static byte FUNCTION_READ_FRAME = (byte)14;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_READ = 8;
	private final static int CALLBACK_ERROR = 9;
	private final static int CALLBACK_FRAME_READABLE = 13;

	public final static short BAUDRATE_300 = (short)0;
	public final static short BAUDRATE_600 = (short)1;
	public final static short BAUDRATE_1200 = (short)2;
	public final static short BAUDRATE_2400 = (short)3;
	public final static short BAUDRATE_4800 = (short)4;
	public final static short BAUDRATE_9600 = (short)5;
	public final static short BAUDRATE_14400 = (short)6;
	public final static short BAUDRATE_19200 = (short)7;
	public final static short BAUDRATE_28800 = (short)8;
	public final static short BAUDRATE_38400 = (short)9;
	public final static short BAUDRATE_57600 = (short)10;
	public final static short BAUDRATE_115200 = (short)11;
	public final static short BAUDRATE_230400 = (short)12;
	public final static short PARITY_NONE = (short)0;
	public final static short PARITY_ODD = (short)1;
	public final static short PARITY_EVEN = (short)2;
	public final static short PARITY_FORCED_PARITY_1 = (short)3;
	public final static short PARITY_FORCED_PARITY_0 = (short)4;
	public final static short STOPBITS_1 = (short)1;
	public final static short STOPBITS_2 = (short)2;
	public final static short WORDLENGTH_5 = (short)5;
	public final static short WORDLENGTH_6 = (short)6;
	public final static short WORDLENGTH_7 = (short)7;
	public final static short WORDLENGTH_8 = (short)8;
	public final static short HARDWARE_FLOWCONTROL_OFF = (short)0;
	public final static short HARDWARE_FLOWCONTROL_ON = (short)1;
	public final static short SOFTWARE_FLOWCONTROL_OFF = (short)0;
	public final static short SOFTWARE_FLOWCONTROL_ON = (short)1;
	public final static short ERROR_OVERRUN = (short)1;
	public final static short ERROR_PARITY = (short)2;
	public final static short ERROR_FRAMING = (short)4;

	private List<OctaveReference> listenerRead = new CopyOnWriteArrayList<OctaveReference>();
	private List<OctaveReference> listenerError = new CopyOnWriteArrayList<OctaveReference>();
	private List<OctaveReference> listenerFrameReadable = new CopyOnWriteArrayList<OctaveReference>();

	public class ReadCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;

		public String[] message;
		public short length;

		public ReadCallbackData(Object device, String[] message, short length) {
			super(device);

			this.message = message;
			this.length = length;
		}

		public String toString() {
			return "[" + "message = " + Arrays.toString(message) + ", " + "length = " + length + "]";
		}
	}

	public class ErrorCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;

		public short error;

		public ErrorCallbackData(Object device, short error) {
			super(device);

			this.error = error;
		}

		public String toString() {
			return "[" + "error = " + error + "]";
		}
	}

	public class FrameReadableCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;

		public short frameCount;

		public FrameReadableCallbackData(Object device, short frameCount) {
			super(device);

			this.frameCount = frameCount;
		}

		public String toString() {
			return "[" + "frameCount = " + frameCount + "]";
		}
	}

	public class Read {
		public String[] message = new String[60];
		public short length;

		public String toString() {
			return "[" + "message = " + Arrays.toString(message) + ", " + "length = " + length + "]";
		}
	}

	public class Configuration {
		public short baudrate;
		public short parity;
		public short stopbits;
		public short wordlength;
		public short hardwareFlowcontrol;
		public short softwareFlowcontrol;

		public String toString() {
			return "[" + "baudrate = " + baudrate + ", " + "parity = " + parity + ", " + "stopbits = " + stopbits + ", " + "wordlength = " + wordlength + ", " + "hardwareFlowcontrol = " + hardwareFlowcontrol + ", " + "softwareFlowcontrol = " + softwareFlowcontrol + "]";
		}
	}

	public class ReadFrame {
		public String[] message = new String[60];
		public short length;

		public String toString() {
			return "[" + "message = " + Arrays.toString(message) + ", " + "length = " + length + "]";
		}
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletRS232(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 3;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_WRITE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_ENABLE_READ_CALLBACK)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_DISABLE_READ_CALLBACK)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_IS_READ_CALLBACK_ENABLED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_BREAK_CONDITION)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_READ_FRAME)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_READ] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 69) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				String[] message = new String[60];
				for (int i = 0; i < 60; i++) {
					message[i] = new String(new char[]{(char)(bb.get())});
				}
				short length = IPConnectionBase.unsignedByte(bb.get());

				for (OctaveReference listener: listenerRead) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new ReadCallbackData(device, message, length)});
				}
			}
		};

		callbacks[CALLBACK_ERROR] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 9) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short error = IPConnectionBase.unsignedByte(bb.get());

				for (OctaveReference listener: listenerError) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new ErrorCallbackData(device, error)});
				}
			}
		};

		callbacks[CALLBACK_FRAME_READABLE] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 9) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short frameCount = IPConnectionBase.unsignedByte(bb.get());

				for (OctaveReference listener: listenerFrameReadable) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new FrameReadableCallbackData(device, frameCount)});
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Writes a string of up to 60 characters to the RS232 interface. The string
	 * can be binary data, ASCII or similar is not necessary.
	 * 
	 * The length of the string has to be given as an additional parameter.
	 * 
	 * The return value is the number of bytes that could be written.
	 * 
	 * See {@link BrickletRS232#setConfiguration(short, short, short, short, short, short)} for configuration possibilities
	 * regarding baudrate, parity and so on.
	 */
	public short write(String[] message, short length) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)69, FUNCTION_WRITE, this);

		for (int i = 0; i < 60; i++) {
			bb.put((byte)message[i].charAt(0));
		}
		bb.put((byte)length);

		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short written = IPConnectionBase.unsignedByte(bb.get());

		return written;
	}

	/**
	 * Returns the currently buffered message. The maximum length
	 * of message is 60. If the returned length is 0, no new data was available.
	 * 
	 * Instead of polling with this function, you can also use
	 * callbacks. See {@link BrickletRS232#enableReadCallback()} and {@link BrickletRS232.ReadListener} listener.
	 */
	public Read read() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ, this);


		byte[] response = sendRequest(bb.array(), 69);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Read obj = new Read();
		for (int i = 0; i < 60; i++) {
			obj.message[i] = new String(new char[]{(char)(bb.get())});
		}
		obj.length = IPConnectionBase.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Enables the {@link BrickletRS232.ReadListener} listener. This will disable the {@link BrickletRS232.FrameReadableListener} listener.
	 * 
	 * By default the listener is disabled.
	 */
	public void enableReadCallback() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_ENABLE_READ_CALLBACK, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Disables the {@link BrickletRS232.ReadListener} listener.
	 * 
	 * By default the listener is disabled.
	 */
	public void disableReadCallback() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_DISABLE_READ_CALLBACK, this);


		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns *true* if the {@link BrickletRS232.ReadListener} listener is enabled,
	 * *false* otherwise.
	 */
	public boolean isReadCallbackEnabled() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_READ_CALLBACK_ENABLED, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean enabled = (bb.get()) != 0;

		return enabled;
	}

	/**
	 * Sets the configuration for the RS232 communication.
	 * 
	 * Hard-/Software flow control can either be on or off but not both simultaneously on.
	 */
	public void setConfiguration(short baudrate, short parity, short stopbits, short wordlength, short hardwareFlowcontrol, short softwareFlowcontrol) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)14, FUNCTION_SET_CONFIGURATION, this);

		bb.put((byte)baudrate);
		bb.put((byte)parity);
		bb.put((byte)stopbits);
		bb.put((byte)wordlength);
		bb.put((byte)hardwareFlowcontrol);
		bb.put((byte)softwareFlowcontrol);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the configuration as set by {@link BrickletRS232#setConfiguration(short, short, short, short, short, short)}.
	 */
	public Configuration getConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 14);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Configuration obj = new Configuration();
		obj.baudrate = IPConnectionBase.unsignedByte(bb.get());
		obj.parity = IPConnectionBase.unsignedByte(bb.get());
		obj.stopbits = IPConnectionBase.unsignedByte(bb.get());
		obj.wordlength = IPConnectionBase.unsignedByte(bb.get());
		obj.hardwareFlowcontrol = IPConnectionBase.unsignedByte(bb.get());
		obj.softwareFlowcontrol = IPConnectionBase.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Sets a break condition (the TX output is forced to a logic 0 state).
	 * The parameter sets the hold-time of the break condition.
	 * 
	 * .. versionadded:: 2.0.2$nbsp;(Plugin)
	 */
	public void setBreakCondition(int breakTime) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_BREAK_CONDITION, this);

		bb.putShort((short)breakTime);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Configures the {@link BrickletRS232.FrameReadableListener} listener. The frame size is the number of bytes, that have to be readable to trigger the listener.
	 * A frame size of 0 disables the listener. A frame size greater than 0 enables the listener and disables the {@link BrickletRS232.ReadListener} listener.
	 * 
	 * By default the listener is disabled.
	 * 
	 * .. versionadded:: 2.0.4$nbsp;(Plugin)
	 */
	public void setFrameReadableCallbackConfiguration(short frameSize) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_SET_FRAME_READABLE_CALLBACK_CONFIGURATION, this);

		bb.put((byte)frameSize);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the listener configuration as set by {@link BrickletRS232#setFrameReadableCallbackConfiguration(short)}.
	 * 
	 * .. versionadded:: 2.0.4$nbsp;(Plugin)
	 */
	public short getFrameReadableCallbackConfiguration() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_FRAME_READABLE_CALLBACK_CONFIGURATION, this);


		byte[] response = sendRequest(bb.array(), 9);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short frameSize = IPConnectionBase.unsignedByte(bb.get());

		return frameSize;
	}

	/**
	 * Returns up to one frame of bytes from the read buffer.
	 * The frame size is configured with {@link BrickletRS232#setFrameReadableCallbackConfiguration(short)}.
	 * If the returned length is 0, no new data was available.
	 * 
	 * .. versionadded:: 2.0.4$nbsp;(Plugin)
	 */
	public ReadFrame readFrame() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_READ_FRAME, this);


		byte[] response = sendRequest(bb.array(), 69);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ReadFrame obj = new ReadFrame();
		for (int i = 0; i < 60; i++) {
			obj.message[i] = new String(new char[]{(char)(bb.get())});
		}
		obj.length = IPConnectionBase.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = new String(new char[]{(char)(bb.get())});
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Read listener.
	 */
	public void addReadCallback(OctaveReference listener) {
		listenerRead.add(listener);
	}

	/**
	 * Removes a Read listener.
	 */
	public void removeReadCallback(OctaveReference listener) {
		listenerRead.remove(listener);
	}

	/**
	 * Adds a Error listener.
	 */
	public void addErrorCallback(OctaveReference listener) {
		listenerError.add(listener);
	}

	/**
	 * Removes a Error listener.
	 */
	public void removeErrorCallback(OctaveReference listener) {
		listenerError.remove(listener);
	}

	/**
	 * Adds a FrameReadable listener.
	 */
	public void addFrameReadableCallback(OctaveReference listener) {
		listenerFrameReadable.add(listener);
	}

	/**
	 * Removes a FrameReadable listener.
	 */
	public void removeFrameReadableCallback(OctaveReference listener) {
		listenerFrameReadable.remove(listener);
	}

	/**
	 * Adds a ReadCallback listener.
	 */
	public void addReadCallbackCallback(OctaveReference listener) { // for backward compatibility
		listenerRead.add(listener);
	}

	/**
	 * Removes a ReadCallback listener.
	 */
	public void removeReadCallbackCallback(OctaveReference listener) { // for backward compatibility
		listenerRead.remove(listener);
	}

	/**
	 * Adds a ErrorCallback listener.
	 */
	public void addErrorCallbackCallback(OctaveReference listener) { // for backward compatibility
		listenerError.add(listener);
	}

	/**
	 * Removes a ErrorCallback listener.
	 */
	public void removeErrorCallbackCallback(OctaveReference listener) { // for backward compatibility
		listenerError.remove(listener);
	}
}
