/* ***********************************************************
 * This file was automatically generated on 2020-07-24.      *
 *                                                           *
 * Octave Bindings Version 2.0.28                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import org.octave.OctaveReference;

/**
 * Measures contactless object temperature between -70°C and +380°C
 */
public class BrickletTemperatureIR extends Device {
	public final static int DEVICE_IDENTIFIER = 217;
	public final static String DEVICE_DISPLAY_NAME = "Temperature IR Bricklet";

	public final static byte FUNCTION_GET_AMBIENT_TEMPERATURE = (byte)1;
	public final static byte FUNCTION_GET_OBJECT_TEMPERATURE = (byte)2;
	public final static byte FUNCTION_SET_EMISSIVITY = (byte)3;
	public final static byte FUNCTION_GET_EMISSIVITY = (byte)4;
	public final static byte FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD = (byte)5;
	public final static byte FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD = (byte)6;
	public final static byte FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_PERIOD = (byte)7;
	public final static byte FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD = (byte)8;
	public final static byte FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD = (byte)9;
	public final static byte FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD = (byte)10;
	public final static byte FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD = (byte)11;
	public final static byte FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD = (byte)12;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)13;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)14;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_AMBIENT_TEMPERATURE = 15;
	private final static int CALLBACK_OBJECT_TEMPERATURE = 16;
	private final static int CALLBACK_AMBIENT_TEMPERATURE_REACHED = 17;
	private final static int CALLBACK_OBJECT_TEMPERATURE_REACHED = 18;

	public final static String THRESHOLD_OPTION_OFF = new String(new char[]{'x'});
	public final static String THRESHOLD_OPTION_OUTSIDE = new String(new char[]{'o'});
	public final static String THRESHOLD_OPTION_INSIDE = new String(new char[]{'i'});
	public final static String THRESHOLD_OPTION_SMALLER = new String(new char[]{'<'});
	public final static String THRESHOLD_OPTION_GREATER = new String(new char[]{'>'});

	private List<OctaveReference> listenerAmbientTemperature = new CopyOnWriteArrayList<OctaveReference>();
	private List<OctaveReference> listenerObjectTemperature = new CopyOnWriteArrayList<OctaveReference>();
	private List<OctaveReference> listenerAmbientTemperatureReached = new CopyOnWriteArrayList<OctaveReference>();
	private List<OctaveReference> listenerObjectTemperatureReached = new CopyOnWriteArrayList<OctaveReference>();

	public class AmbientTemperatureCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;

		public short temperature;

		public AmbientTemperatureCallbackData(Object device, short temperature) {
			super(device);

			this.temperature = temperature;
		}

		public String toString() {
			return "[" + "temperature = " + temperature + "]";
		}
	}

	public class ObjectTemperatureCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;

		public short temperature;

		public ObjectTemperatureCallbackData(Object device, short temperature) {
			super(device);

			this.temperature = temperature;
		}

		public String toString() {
			return "[" + "temperature = " + temperature + "]";
		}
	}

	public class AmbientTemperatureReachedCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;

		public short temperature;

		public AmbientTemperatureReachedCallbackData(Object device, short temperature) {
			super(device);

			this.temperature = temperature;
		}

		public String toString() {
			return "[" + "temperature = " + temperature + "]";
		}
	}

	public class ObjectTemperatureReachedCallbackData extends java.util.EventObject {
		private static final long serialVersionUID = 1L;

		public short temperature;

		public ObjectTemperatureReachedCallbackData(Object device, short temperature) {
			super(device);

			this.temperature = temperature;
		}

		public String toString() {
			return "[" + "temperature = " + temperature + "]";
		}
	}

	public class AmbientTemperatureCallbackThreshold {
		public String option;
		public short min;
		public short max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	public class ObjectTemperatureCallbackThreshold {
		public String option;
		public short min;
		public short max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletTemperatureIR(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;

		deviceIdentifier = DEVICE_IDENTIFIER;
		deviceDisplayName = DEVICE_DISPLAY_NAME;

		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_AMBIENT_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_OBJECT_TEMPERATURE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_EMISSIVITY)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_EMISSIVITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnectionBase.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_AMBIENT_TEMPERATURE] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short temperature = (bb.getShort());

				for (OctaveReference listener: listenerAmbientTemperature) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new AmbientTemperatureCallbackData(device, temperature)});
				}
			}
		};

		callbacks[CALLBACK_OBJECT_TEMPERATURE] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short temperature = (bb.getShort());

				for (OctaveReference listener: listenerObjectTemperature) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new ObjectTemperatureCallbackData(device, temperature)});
				}
			}
		};

		callbacks[CALLBACK_AMBIENT_TEMPERATURE_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short temperature = (bb.getShort());

				for (OctaveReference listener: listenerAmbientTemperatureReached) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new AmbientTemperatureReachedCallbackData(device, temperature)});
				}
			}
		};

		callbacks[CALLBACK_OBJECT_TEMPERATURE_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(Device device, byte[] packet) {
				if (packet.length != 10) {
					return; // silently ignoring callback with wrong length
				}

				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				short temperature = (bb.getShort());

				for (OctaveReference listener: listenerObjectTemperatureReached) {
					IPConnection.doOctaveInvoke(listener, new Object[]{new ObjectTemperatureReachedCallbackData(device, temperature)});
				}
			}
		};

		ipcon.addDevice(this);
	}

	/**
	 * Returns the ambient temperature of the sensor.
	 * 
	 * If you want to get the ambient temperature periodically, it is recommended
	 * to use the {@link BrickletTemperatureIR.AmbientTemperatureListener} listener and set the period with
	 * {@link BrickletTemperatureIR#setAmbientTemperatureCallbackPeriod(long)}.
	 */
	public short getAmbientTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AMBIENT_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Returns the object temperature of the sensor, i.e. the temperature
	 * of the surface of the object the sensor is aimed at.
	 * 
	 * The temperature of different materials is dependent on their `emissivity
	 * &lt;https://en.wikipedia.org/wiki/Emissivity&gt;`__. The emissivity of the material
	 * can be set with {@link BrickletTemperatureIR#setEmissivity(int)}.
	 * 
	 * If you want to get the object temperature periodically, it is recommended
	 * to use the {@link BrickletTemperatureIR.ObjectTemperatureListener} listener and set the period with
	 * {@link BrickletTemperatureIR#setObjectTemperatureCallbackPeriod(long)}.
	 */
	public short getObjectTemperature() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_OBJECT_TEMPERATURE, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short temperature = (bb.getShort());

		return temperature;
	}

	/**
	 * Sets the `emissivity &lt;https://en.wikipedia.org/wiki/Emissivity&gt;`__ that is
	 * used to calculate the surface temperature as returned by
	 * {@link BrickletTemperatureIR#getObjectTemperature()}.
	 * 
	 * The emissivity is usually given as a value between 0.0 and 1.0. A list of
	 * emissivities of different materials can be found
	 * `here &lt;https://www.infrared-thermography.com/material.htm&gt;`__.
	 * 
	 * The parameter of {@link BrickletTemperatureIR#setEmissivity(int)} has to be given with a factor of
	 * 65535 (16-bit). For example: An emissivity of 0.1 can be set with the
	 * value 6553, an emissivity of 0.5 with the value 32767 and so on.
	 * 
	 * \note
	 *  If you need a precise measurement for the object temperature, it is
	 *  absolutely crucial that you also provide a precise emissivity.
	 * 
	 * The emissivity is stored in non-volatile memory and will still be used after a restart or power cycle of the Bricklet.
	 */
	public void setEmissivity(int emissivity) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_EMISSIVITY, this);

		bb.putShort((short)emissivity);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the emissivity as set by {@link BrickletTemperatureIR#setEmissivity(int)}.
	 */
	public int getEmissivity() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_EMISSIVITY, this);


		byte[] response = sendRequest(bb.array(), 10);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int emissivity = IPConnectionBase.unsignedShort(bb.getShort());

		return emissivity;
	}

	/**
	 * Sets the period with which the {@link BrickletTemperatureIR.AmbientTemperatureListener} listener is
	 * triggered periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletTemperatureIR.AmbientTemperatureListener} listener is only triggered if the temperature has
	 * changed since the last triggering.
	 */
	public void setAmbientTemperatureCallbackPeriod(long period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the period as set by {@link BrickletTemperatureIR#setAmbientTemperatureCallbackPeriod(long)}.
	 */
	public long getAmbientTemperatureCallbackPeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnectionBase.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the period with which the {@link BrickletTemperatureIR.ObjectTemperatureListener} listener is
	 * triggered periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletTemperatureIR.ObjectTemperatureListener} listener is only triggered if the temperature
	 * has changed since the last triggering.
	 */
	public void setObjectTemperatureCallbackPeriod(long period) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the period as set by {@link BrickletTemperatureIR#setObjectTemperatureCallbackPeriod(long)}.
	 */
	public long getObjectTemperatureCallbackPeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnectionBase.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the thresholds for the {@link BrickletTemperatureIR.AmbientTemperatureReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the ambient temperature is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the ambient temperature is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the ambient temperature is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the ambient temperature is greater than the min value (max is ignored)"
	 * \endverbatim
	 */
	public void setAmbientTemperatureCallbackThreshold(String option, short min, short max) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD, this);

		bb.put((byte)option.charAt(0));
		bb.putShort(min);
		bb.putShort(max);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the threshold as set by {@link BrickletTemperatureIR#setAmbientTemperatureCallbackThreshold(String, short, short)}.
	 */
	public AmbientTemperatureCallbackThreshold getAmbientTemperatureCallbackThreshold() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array(), 13);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		AmbientTemperatureCallbackThreshold obj = new AmbientTemperatureCallbackThreshold();
		obj.option = new String(new char[]{(char)(bb.get())});
		obj.min = (bb.getShort());
		obj.max = (bb.getShort());

		return obj;
	}

	/**
	 * Sets the thresholds for the {@link BrickletTemperatureIR.ObjectTemperatureReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the object temperature is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the object temperature is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the object temperature is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the object temperature is greater than the min value (max is ignored)"
	 * \endverbatim
	 */
	public void setObjectTemperatureCallbackThreshold(String option, short min, short max) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD, this);

		bb.put((byte)option.charAt(0));
		bb.putShort(min);
		bb.putShort(max);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the threshold as set by {@link BrickletTemperatureIR#setObjectTemperatureCallbackThreshold(String, short, short)}.
	 */
	public ObjectTemperatureCallbackThreshold getObjectTemperatureCallbackThreshold() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array(), 13);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		ObjectTemperatureCallbackThreshold obj = new ObjectTemperatureCallbackThreshold();
		obj.option = new String(new char[]{(char)(bb.get())});
		obj.min = (bb.getShort());
		obj.max = (bb.getShort());

		return obj;
	}

	/**
	 * Sets the period with which the threshold listeners
	 * 
	 * * {@link BrickletTemperatureIR.AmbientTemperatureReachedListener},
	 * * {@link BrickletTemperatureIR.ObjectTemperatureReachedListener}
	 * 
	 * are triggered, if the thresholds
	 * 
	 * * {@link BrickletTemperatureIR#setAmbientTemperatureCallbackThreshold(String, short, short)},
	 * * {@link BrickletTemperatureIR#setObjectTemperatureCallbackThreshold(String, short, short)}
	 * 
	 * keep being reached.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array(), 0);
	}

	/**
	 * Returns the debounce period as set by {@link BrickletTemperatureIR#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		checkValidity();

		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array(), 12);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnectionBase.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array(), 33);

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnectionBase.string(bb, 8);
		obj.connectedUid = IPConnectionBase.string(bb, 8);
		obj.position = new String(new char[]{(char)(bb.get())});
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnectionBase.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnectionBase.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a AmbientTemperature listener.
	 */
	public void addAmbientTemperatureCallback(OctaveReference listener) {
		listenerAmbientTemperature.add(listener);
	}

	/**
	 * Removes a AmbientTemperature listener.
	 */
	public void removeAmbientTemperatureCallback(OctaveReference listener) {
		listenerAmbientTemperature.remove(listener);
	}

	/**
	 * Adds a ObjectTemperature listener.
	 */
	public void addObjectTemperatureCallback(OctaveReference listener) {
		listenerObjectTemperature.add(listener);
	}

	/**
	 * Removes a ObjectTemperature listener.
	 */
	public void removeObjectTemperatureCallback(OctaveReference listener) {
		listenerObjectTemperature.remove(listener);
	}

	/**
	 * Adds a AmbientTemperatureReached listener.
	 */
	public void addAmbientTemperatureReachedCallback(OctaveReference listener) {
		listenerAmbientTemperatureReached.add(listener);
	}

	/**
	 * Removes a AmbientTemperatureReached listener.
	 */
	public void removeAmbientTemperatureReachedCallback(OctaveReference listener) {
		listenerAmbientTemperatureReached.remove(listener);
	}

	/**
	 * Adds a ObjectTemperatureReached listener.
	 */
	public void addObjectTemperatureReachedCallback(OctaveReference listener) {
		listenerObjectTemperatureReached.add(listener);
	}

	/**
	 * Removes a ObjectTemperatureReached listener.
	 */
	public void removeObjectTemperatureReachedCallback(OctaveReference listener) {
		listenerObjectTemperatureReached.remove(listener);
	}
}
